;=============================================
;   
;  - 4
;=============================================
	list      p=16F84
	#include  <p16F84.inc>
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_OFF & _HS_OSC ; 3FFA
;=============================================
Status	equ	03h
PortA	equ	05h
TrisA	equ	05h
PortB	equ	06h
TrisB	equ	06h 
OptionR equ	01h 
tim1	equ	0Dh	; 
tim2	equ	0Eh	; 
spid	equ	18h	; 
temp	equ	19h	; 
; - - - - - - - - - - - - - - - -

;=============================================
;  
;=============================================
;RA0		;   1
;RA1		;   2  
;RA2		;   3
;RA3		;   4
;=============================================
;  B   RB0-RB4
;=============================================
;Plus1	equ	5	;  
;Minus1	equ	6	;  
;left1	equ	3	; 
;right1	equ	4	; 
;stop1	equ	7	; 
;=============================================
	org		0h
	goto	Start
;=============================================
Start
;=============================================
; 
;=============================================
		clrf	PortA
		clrf	PortB
		bsf		Status,5
		movlw	b'11110000'	;RA0-RA3 
		movwf	TrisA
		movlw	b'11111111'	;RB0-RB4  - 
		movwf	TrisB
		bcf		OptionR,7 
		bcf		Status,5
		movlw	h'3F'		;  
		movwf	spid		
;=============================================
;  
;=============================================
	goto 	Key
;=============================================
; .
;=============================================
Key	btfss	PortB,3		;  
	goto	left			; 
	btfss	PortB,4 	;  
	goto	right			; 
	goto 	Key
;=============================================
;  
;=============================================
left	movlw	b'00001000'
		movwf	PORTA		; +  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7	;  
	goto	Key
		movlw	b'00000001'
		movwf	PORTA		; +  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7			;  
	goto	Key
		movlw	b'00000100'
		movwf	PORTA		; -  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7			;  
	goto	Key		
		movlw	b'00000010'
		movwf	PORTA		; -  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7			;  
	goto	Key
		btfss	PortB,5		;  
		call	plus			; 
		btfss	PortB,6 	;  
		call	minus			; 
		goto	left
;=============================================
;  
;=============================================
right	movlw	b'00000010'
		movwf	PORTA		; +  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7		;  
	goto	Key
		movlw	b'00000100'
		movwf	PORTA		; +  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7		;  
	goto	Key
		movlw	b'00000001'
		movwf	PORTA		; -  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7		;  
	goto	Key		
		movlw	b'00001000'
		movwf	PORTA		; -  
		call	Pauseb		; 
		call	Pausem
		movlw	b'00000000'
		movwf	PORTA		;  
	btfss	PortB,7		;  
	goto	Key
		btfss	PortB,5		;  
		call	plus			; 
		btfss	PortB,6 	;  
		call	minus			; 
		goto	right
;=============================================
; 
;=============================================
plus	decfsz	spid,f
		return
		incf	spid,f
		return	
;=============================================
; 
;=============================================
minus	incfsz	spid,f
		return
		decf	spid,f
		return
;=============================================
; 
;=============================================
Pauseb	movf		spid,w			;      ( )
		movwf		tim1			;      tim1
cycle1	movf		spid,w			;      ( )
		movwf		tim2			;       tim2
cycle2	decfsz		tim2,f			;  tim2   (-1)
		goto		cycle2			;   0, 
		decfsz		tim1,f			;  tim1   (-1)
		goto		cycle1			;   0, 
		return	
;=============================================
; 
;=============================================
Pausem			
	movlw	.255
	movwf	temp
Pausm2   
	decfsz  temp,f
	goto    Pausm2
	return
;=============================================
;=============================================
;=============================================
	end

